# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .comment_public import CommentPublic
from .error_info_public import ErrorInfoPublic
from .feedback_score_public import FeedbackScorePublic
from .guardrails_validation_public import GuardrailsValidationPublic
from .json_list_string_public import JsonListStringPublic
from .json_node_public import JsonNodePublic
from .trace_public_visibility_mode import TracePublicVisibilityMode


class TracePublic(UniversalBaseModel):
    id: typing.Optional[str] = None
    project_id: typing.Optional[str] = None
    name: typing.Optional[str] = None
    start_time: dt.datetime
    end_time: typing.Optional[dt.datetime] = None
    input: typing.Optional[JsonListStringPublic] = None
    output: typing.Optional[JsonListStringPublic] = None
    metadata: typing.Optional[JsonNodePublic] = None
    tags: typing.Optional[typing.List[str]] = None
    error_info: typing.Optional[ErrorInfoPublic] = None
    usage: typing.Optional[typing.Dict[str, int]] = None
    created_at: typing.Optional[dt.datetime] = None
    last_updated_at: typing.Optional[dt.datetime] = None
    created_by: typing.Optional[str] = None
    last_updated_by: typing.Optional[str] = None
    feedback_scores: typing.Optional[typing.List[FeedbackScorePublic]] = None
    comments: typing.Optional[typing.List[CommentPublic]] = None
    guardrails_validations: typing.Optional[typing.List[GuardrailsValidationPublic]] = None
    total_estimated_cost: typing.Optional[float] = None
    span_count: typing.Optional[int] = None
    duration: typing.Optional[float] = pydantic.Field(default=None)
    """
    Duration in milliseconds as a decimal number to support sub-millisecond precision
    """

    thread_id: typing.Optional[str] = None
    visibility_mode: typing.Optional[TracePublicVisibilityMode] = None
    llm_span_count: typing.Optional[int] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
